package com.sun.xml.internal.bind.v2.model.impl;

import javax.activation.MimeTypeParseException;
import com.sun.xml.internal.bind.v2.runtime.IllegalAnnotationException;
import javax.xml.bind.annotation.XmlMimeType;
import javax.activation.MimeType;
import javax.xml.bind.annotation.XmlSchemaTypes;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.namespace.QName;
import com.sun.xml.internal.bind.v2.model.annotation.Locatable;
import com.sun.xml.internal.bind.v2.model.annotation.AnnotationSource;
import com.sun.xml.internal.bind.v2.model.annotation.AnnotationReader;

final class Util
{
    Util() {
    }
    
    static <T, C, F, M> QName calcSchemaType(AnnotationReader<T, C, F, M> reader, AnnotationSource primarySource, C enclosingClass, T individualType, Locatable src) {
        XmlSchemaType xst = (XmlSchemaType)primarySource.readAnnotation(XmlSchemaType.class);
        if (xst != null) {
            return new QName(xst.namespace(), xst.name());
        }
        XmlSchemaTypes xsts = (XmlSchemaTypes)reader.getPackageAnnotation(XmlSchemaTypes.class, enclosingClass, src);
        XmlSchemaType[] values = null;
        if (xsts != null) {
            values = xsts.value();
        }
        else {
            xst = (XmlSchemaType)reader.getPackageAnnotation(XmlSchemaType.class, enclosingClass, src);
            if (xst != null) {
                values = new XmlSchemaType[] { xst };
            }
        }
        if (values != null) {
            int length = values.length;
            int i = 0;
            while (i < length) {
                XmlSchemaType item = values[i];
                if (reader.getClassValue(item, "type").equals(individualType)) {
                    return new QName(item.namespace(), item.name());
                }
                ++i;
            }
        }
        return null;
    }
    
    static MimeType calcExpectedMediaType(AnnotationSource primarySource, ModelBuilder builder) {
        XmlMimeType xmt = (XmlMimeType)primarySource.readAnnotation(XmlMimeType.class);
        if (xmt == null) {
            return null;
        }
        try {
            return new MimeType(xmt.value());
        }
        catch (MimeTypeParseException e) {
            builder.reportError(new IllegalAnnotationException(Messages.ILLEGAL_MIME_TYPE.format(new Object[] { xmt.value(), e.getMessage() }), xmt));
            return null;
        }
    }
}
